Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 156 by niro, Sat Jul 23 16:34:29 2005 UTC branches/mage-next/src/smage2.in revision 2614 by niro, Tue Mar 4 15:27:52 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.14 2005-07-23 16:34:29 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  SMAGEVERSION=0.3.6-r18  : ${MAGERC="/etc/mage.rc"}
 PKGSUFFIX="mpk"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
   
 source /etc/mage.rc  
   
 showversion() {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
12    
13  xtitle() {  # export default C locale
14   if [ ${TERM} == "xterm" ]  export LC_ALL=C
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
15    
16   # subdir in sources dir; the my_SRCI_URI file goes to there  source /etc/mage.rc.global
17   my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21   # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  # export default path
22   if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  export PATH="${PATH}:${MLIBDIR}"
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
23    
24   # if an mirrored file than replace first the mirror uri  ## setup ##
25   if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  SMAGENAME="$1"
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
   
 build_mage_script() {  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
26    
27  setup_ccache_environment(){  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
28   if [ -x /usr/bin/ccache ]  if [[ -n ${MROOT} ]]
29   then  then
30   echo "Using CCache for compilation ..."   export PKGDIR=${MROOT}/${PKGDIR}
31   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export BUILDDIR=${MROOT}/${BUILDDIR}
32   #unset CC CXX   export BINDIR=${MROOT}/${BINDIR}
33   fi  fi
 }  
34    
35  # print out our version  # print out our version
36  showversion  showversion
37  echo  echo
38    
39  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
40  then  then
41   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
42   echo   echo
43   exit 1   exit 1
44  fi  fi
45    
46  #updating smage2-scripts  # load supported mage features
47  if [ "$1" == "update" ]  load_mage_features
48    
49    # updating smage2-scripts
50    if [[ $1 = update ]]
51  then  then
52   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
53   then   then
# Line 416  then Line 57  then
57   exit 0   exit 0
58  fi  fi
59    
60  #creates md5sums for smages to given dir  # creates md5sums for smages to given dir
61  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
62  then  then
63   if [ $# -ge 3 ]   if [ $# -ge 2 ]
64   then   then
65   SMAGENAME="$2"   SMAGENAME="$2"
66   MD5DIR="$3"   MD5DIR="$3"
67   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
68    
69     smagesource ${SMAGENAME} || die "download source failed"
70    
71   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
72   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 469  then Line 112  then
112   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
113   unset my_SOURCEDIR   unset my_SOURCEDIR
114   done   done
115    
116   echo   echo
117   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
118   echo   echo
119   else   else
120   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
121   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
122   echo   echo
123   echo   echo
124   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
125   echo   echo
126   exit 1   exit 1
127   fi   fi
128    
129   exit 0   exit 0
130  fi  fi
131    
132  #download sources  # download sources
133  if [ "$1" == "download" -a -n "$2" ]  if [ "$1" == "download" -a -n "$2" ]
134  then  then
  showversion  
135   if [ ! -d ${SMAGESCRIPTSDIR} ]   if [ ! -d ${SMAGESCRIPTSDIR} ]
136   then   then
137   install -d ${SMAGESCRIPTSDIR}   install -d ${SMAGESCRIPTSDIR}
# Line 498  then Line 140  then
140   # get smage   # get smage
141   SMAGENAME="$2"   SMAGENAME="$2"
142   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
143   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
144    
145   download_sources   download_sources
146   exit 0   exit 0
147  fi  fi
148    
149  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
150    if [ "$1" == "only-regen-tree" -a -n "$2" ]
151  then  then
152   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
153  fi   SMAGENAME="$2"
154     MD5DIR="$(dirname ${SMAGENAME})/md5"
155     smagesource ${SMAGENAME} || die "regen: smage2 not found"
156    
157  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
158    
159  if [ -z "${SOURCEDIR}" ]   # build several subpackages
160  then   if [[ -n ${SPLIT_PACKAGES} ]]
161   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
162  fi   split_save_variables
163     for subpackage in ${SPLIT_PACKAGES}
164     do
165     # get the right variables for the split
166     export PNAME="${subpackage}"
167     split_info_${subpackage}
168     # fix PCATEGORIE -> PCAT
169     if [[ ! -z ${PCATEGORIE} ]]
170     then
171     PCAT="${PCATEGORIE}"
172     unset PCATEGORIE
173     fi
174     # build md5sum for existing packages
175     generate_package_md5sum \
176     --pcat "${PCAT}" \
177     --pname "${PNAME}" \
178     --pver "${PVER}" \
179     --pbuild "${PBUILD}" \
180     --parch "${ARCH}"
181     # restore smage environment
182     split_restore_variables
183     done
184     # unset all saved smage variables
185     split_unset_variables
186    
187  if [ -z "${SMAGESCRIPTSDIR}" ]   else
188  then   # build md5sum for existing packages
189   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   generate_package_md5sum \
190  fi   --pcat "${PCAT}" \
191     --pname "${PNAME}" \
192     --pver "${PVER}" \
193     --pbuild "${PBUILD}" \
194     --parch "${ARCH}"
195     fi
196    
197  if [ -z "${SMAGE2RSYNC}" ]   exit 0
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
198  fi  fi
199    
200  if [ -z "${BINDIR}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
201  then  then
202   die "no BINDIR variable found in /etc/mage.rc"   # set correct SMAGENAME
203  fi   SMAGENAME="$2"
204     MD5DIR="$(dirname ${SMAGENAME})/md5"
205    
206  if [ -z "${CHOST}" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
207  then  
208   die "no CHOST variable found in /etc/mage.rc"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
209    
210     if [[ -d ${SOURCEDIR}/${PNAME} ]]
211     then
212     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
213     rm -rf ${SOURCEDIR}/${PKGNAME}
214     fi
215    
216     download_sources
217     source_pkg_build ${SMAGENAME}
218     exit 0
219  fi  fi
220    
221  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
222  then  then
223   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
224     msetfeature "srcpkgtarball"
225    
226     # abort if given file is not a source pkg
227     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
228    
229     # set correct SMAGENAME; use the one that the src_pkg provide
230     # /path/to/SOURCEDIR/PNAME/SMAGENAME
231     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
232    
233     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
234    
235     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
236    
237     # unpack srctarball
238     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
239    
240     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
241    
242     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
243  fi  fi
244    
245  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
246  then  then
247   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
248     SMAGENAME="$2"
249  fi  fi
250    
251    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
252    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
253     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
254    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
255    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
256    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
257    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
258    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
259    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
260    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
261    
262  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
263  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
264  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
265    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
266    
267  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
268  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
269    
270  #download sources  if mqueryfeature "srcpkgbuild"
271  download_sources  then
272     if [[ -d ${SOURCEDIR}/${PNAME} ]]
273     then
274     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
275     rm -rf ${SOURCEDIR}/${PNAME}
276     fi
277    fi
278    
279  #fixes some issues with these functions  # download sources
280    mqueryfeature "srcpkgtarball" || download_sources
281    
282    # fixes some issues with these functions
283  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
284  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
285    export -f src_check || die "src_check export failed"
286  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
287    
288  #fixes some compile issues  # fixes some compile issues
289  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
290  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
291  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
292    then
293     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
294    else
295     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
296    fi
297    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
298  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
299  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
300    
301    # setup distcc
302    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
303    mqueryfeature "distcc" && setup_distcc_environment
304    
305  #setup distcc  # setup icecc
306  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
307  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "icecc" && setup_icecc_environment
308    
309    # setup ccache
310    mqueryfeature "ccache" && setup_ccache_environment
311    
312    if mqueryfeature "resume"
313  then  then
314   setup_distcc_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
315    
316     # setup build logging
317     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
318     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
319     then
320     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
321     fi
322     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
323    
324    else
325     # clean up builddir if a previously one exist
326     if [ -d ${BUILDDIR} ]
327     then
328     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
329     fi
330     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
331    
332     # clean up srcdir if a previously unpacked one exist
333     if [ -d ${SRCDIR} ]
334     then
335     rm -rf ${SRCDIR}
336     fi
337    
338     # clean up bindir if a previous build exist or create a new one
339     if [ -d ${BINDIR} ]
340     then
341     rm -rf ${BINDIR}
342     fi
343     install -d ${BINDIR} || die "couldn't create \$BINDIR."
344    
345     # clean up package temp dir if a previous build exist
346     if [ -d ${BUILDDIR}/${PKGNAME} ]
347     then
348     rm -rf ${BUILDDIR}/${PKGNAME}
349     fi
350    
351     # clean up stamps dir
352     if [ -d ${BUILDDIR}/.stamps ]
353     then
354     rm -rf ${BUILDDIR}/.stamps
355     fi
356    
357     # setup build logging
358     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
359     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
360  fi  fi
361    
362  #setup ccache  if [[ ${PKGTYPE} = virtual ]]
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
363  then  then
364   setup_ccache_environment   echo "virtual package detected; nothing will be build ..."
365  fi   # automatically set !pkgbuild here too
366     msetfeature "!pkgbuild"
367    else
368     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
369     die_pipestatus 0 "src_prepare failed"
370     resume_stamp src_prepare
371     step_by_step src_prepare
372    
373     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
374     die_pipestatus 0 "src_compile failed"
375     resume_stamp src_compile
376     step_by_step src_compile
377    
378  # small sleep to show our settings   # only run checks if requested
379  sleep 1   if mqueryfeature "!check"
380     then
381     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
382     else
383     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
384     die_pipestatus 0 "src_check failed"
385     resume_stamp src_check
386     fi
387     step_by_step src_check
388    
389     # build several subpackages
390     if [[ -n ${SPLIT_PACKAGES} ]]
391     then
392     # save bindir & pname
393     split_save_variables
394     export SAVED_BINDIR="${BINDIR}"
395     for subpackage in ${SPLIT_PACKAGES}
396     do
397     split_info_${subpackage}
398     if [[ ${PKGTYPE} = virtual ]]
399     then
400     echo
401     echo -en "${COLBLUE}*** ${COLDEFAULT}"
402     echo -en "Virtual package detected"
403     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
404     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
405    
406     echo "virtual package detected; nothing will be build ..."
407     # automatically set !pkgbuild here too
408     msetfeature "!pkgbuild"
409     else
410     if typeset -f src_install_${subpackage} > /dev/null
411     then
412     # export subpackage bindir
413     export BINDIR="${SAVED_BINDIR}_${subpackage}"
414     # export PNAME, several internal function and include
415     # rely on this variable
416     export PNAME="${subpackage}"
417    
418     echo
419     echo -en "${COLBLUE}*** ${COLDEFAULT}"
420     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
421     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
422     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
423    
424     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
425     die_pipestatus 0 "src_install_${subpackage} failed"
426     resume_stamp src_install_${subpackage}
427     step_by_step src_install_${subpackage}
428     fi
429     fi
430     # restore smage environment
431     split_restore_variables
432     done
433     # unset all saved smage variables
434     split_unset_variables
435     else
436     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
437     die_pipestatus 0 "src_install failed"
438     resume_stamp src_install
439     step_by_step src_install
440     fi
441    fi
442    
443  #debug  # echo for sake of good-looking
444  #echo "CC=${CC}"  echo
 #echo "CXX=${CXX}"  
 #echo "DISTCC_DIR=${DISTCC_DIR}"  
 #echo "PATH: ${PATH}"  
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
445    
446  #cleans up build if a previously one exists  if mqueryfeature "!compressdoc"
 if [ -d ${BUILDDIR} ]  
447  then  then
448   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "!compressdoc detected; documentation will not be compressed ..."
449    elif mqueryfeature "!pkgbuild"
450    then
451     echo "!pkgbuild detected; skipping documentation compression..."
452    else
453     # compressing doc, info & man files
454     if [[ -n ${SPLIT_PACKAGES} ]]
455     then
456     # save smage environment
457     split_save_variables
458     for subpackage in ${SPLIT_PACKAGES}
459     do
460     # honor split_info
461     split_info_${subpackage}
462     if [[ ${PKGTYPE} = virtual ]]
463     then
464     # automatically set !pkgbuild here too
465     msetfeature "!pkgbuild"
466     fi
467    
468     if mqueryfeature "!compressdoc"
469     then
470     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
471     elif mqueryfeature "!pkgbuild"
472     then
473     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
474     else
475     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
476     resume_stamp post-mcompressdoc_${subpackage}
477     fi
478     # restore smage environment
479     split_restore_variables
480     done
481     # unset saved variables
482     split_unset_variables
483     else
484     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
485     resume_stamp post-mcompressdoc
486     fi
487  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
488    
489  #cleans up srcdir if a previously unpacked one exists  if mqueryfeature "!libtool"
 if [ -d ${SRCDIR} ]  
490  then  then
491   rm -rf ${SRCDIR}   if mqueryfeature "!pkgbuild"
492     then
493     echo "!pkgbuild detected; skipping libtool archive stripping ..."
494     else
495     if [[ -n ${SPLIT_PACKAGES} ]]
496     then
497     # save smage environment
498     split_save_variables
499     for subpackage in ${SPLIT_PACKAGES}
500     do
501     # honor split_info
502     split_info_${subpackage}
503     if [[ ${PKGTYPE} = virtual ]]
504     then
505     # automatically set !pkgbuild here too
506     msetfeature "!pkgbuild"
507     fi
508    
509     if mqueryfeature "!libtool"
510     then
511     if mqueryfeature "!pkgbuild"
512     then
513     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
514     else
515     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
516     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
517     resume_stamp post-mstriplibtoolarchive_${subpackage}
518     fi
519     fi
520    
521     # restore smage environment
522     split_restore_variables
523     done
524     # unset saved variables
525     split_unset_variables
526     else
527     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
528     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
529     resume_stamp post-mstriplibtoolarchive
530     fi
531     fi
532  fi  fi
533    
534  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "purge"
 if [ -d ${BINDIR} ]  
535  then  then
536   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
537     then
538     echo "!pkgbuild detected; skipping file purgation ..."
539     else
540     if [[ -n ${SPLIT_PACKAGES} ]]
541     then
542     # save smage environment
543     split_save_variables
544     for subpackage in ${SPLIT_PACKAGES}
545     do
546     # honor split_info
547     split_info_${subpackage}
548     if [[ ${PKGTYPE} = virtual ]]
549     then
550     # automatically set !pkgbuild here too
551     msetfeature "!pkgbuild"
552     fi
553    
554     if mqueryfeature "purge"
555     then
556     if mqueryfeature "!pkgbuild"
557     then
558     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
559     else
560     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
561     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
562     resume_stamp post-mpurgetargets_${subpackage}
563     fi
564     fi
565    
566     # restore smage environment
567     split_restore_variables
568     done
569     # unset saved variables
570     split_unset_variables
571     else
572     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
573     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
574     resume_stamp post-mpurgetargets
575     fi
576     fi
577  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
578    
579  #cleans up package temp dir if a previous build exists  # stripping all bins and libs
580  if [ -d ${BUILDDIR}/${PKGNAME} ]  if mqueryfeature "!strip"
581  then  then
582   rm -rf ${BUILDDIR}/${PKGNAME}   echo -e "!strip detected; package will not be stripped ..."
583    elif mqueryfeature "!pkgbuild"
584    then
585     echo "!pkgbuild detected; skipping stripping of the package ..."
586    else
587     if [[ -n ${SPLIT_PACKAGES} ]]
588     then
589     # save smage environment
590     split_save_variables
591     for subpackage in ${SPLIT_PACKAGES}
592     do
593     # honor split_info
594     split_info_${subpackage}
595     if [[ ${PKGTYPE} = virtual ]]
596     then
597     # automatically set !pkgbuild here too
598     msetfeature "!pkgbuild"
599     fi
600    
601     if mqueryfeature "!strip"
602     then
603     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
604     elif mqueryfeature "!pkgbuild"
605     then
606     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
607     else
608     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
609     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
610     resume_stamp post-mstripbins_${subpackage}
611     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
612     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
613     resume_stamp post-mstriplibs_${subpackage}
614     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
615     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
616     resume_stamp post-mstripstatic_${subpackage}
617     fi
618    
619     # restore smage environment
620     split_restore_variables
621     done
622     # unset saved variables
623     split_unset_variables
624     else
625     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
626     run_resume post-mstripbins || mstripbins ${BINDIR}
627     resume_stamp post-mstripbins
628     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
629     run_resume post-mstriplibs || mstriplibs ${BINDIR}
630     resume_stamp post-mstriplibs
631     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
632     run_resume post-mstripstatic || mstripstatic ${BINDIR}
633     resume_stamp post-mstripstatic
634     fi
635  fi  fi
636    
637  #cleans up timestamp if one exists  if mqueryfeature "qalint"
 if [ -f /var/tmp/timestamp ]  
638  then  then
639   mage rmstamp   if mqueryfeature "!pkgbuild"
640  fi   then
641     echo "!pkgbuild detected; skipping QA lint checks ..."
642     else
643     if [[ -n ${SPLIT_PACKAGES} ]]
644     then
645     # save smage environment
646     split_save_variables
647     for subpackage in ${SPLIT_PACKAGES}
648     do
649     # honor split_info
650     split_info_${subpackage}
651     if [[ ${PKGTYPE} = virtual ]]
652     then
653     # automatically set !pkgbuild here too
654     msetfeature "!pkgbuild"
655     fi
656    
657  src_prepare || die "src_prepare failed"   if mqueryfeature "qalint"
658  src_compile || die "src_compile failed"   then
659  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
660     then
661     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
662     else
663     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
664     mqalint ${BINDIR}_${subpackage}
665     fi
666     fi
667    
668     # restore smage environment
669     split_restore_variables
670     done
671     # unset saved variables
672     split_unset_variables
673     else
674     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
675     mqalint ${BINDIR}
676     fi
677     fi
678    fi
679    
680  #compressing doc, info & man files  if mqueryfeature "!pkgbuild"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
681  then  then
682   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo -e "!pkgbuild detected; Package will not be build ..."
683    else
684     # build several subpackages
685     if [[ -n ${SPLIT_PACKAGES} ]]
686     then
687     split_save_variables
688     for subpackage in ${SPLIT_PACKAGES}
689     do
690     # get the right variables for the split
691     export PNAME="${subpackage}"
692     split_info_${PNAME}
693     # fix PCATEGORIE -> PCAT
694     if [[ ! -z ${PCATEGORIE} ]]
695     then
696     PCAT="${PCATEGORIE}"
697     unset PCATEGORIE
698     fi
699     if [[ ${PKGTYPE} = virtual ]]
700     then
701     # automatically set !pkgbuild here too
702     msetfeature "!pkgbuild"
703     fi
704    
705     # jump to next one if !pkgbuild is set in split_info
706     if mqueryfeature "!pkgbuild"
707     then
708     # restore smage environment
709     split_restore_variables
710     continue
711     fi
712    
713     # check if an special subpackage_pkgbuild exists
714     if typeset -f ${PNAME}_pkgbuild > /dev/null
715     then
716     # run it
717     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
718     resume_stamp post-${PNAME}_pkgbuild
719     fi
720     # now create the target package
721     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
722     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
723     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
724     resume_stamp post-pkg_builddir_${PNAME}
725    
726     # build pkg-md5-sum if requested
727     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
728     --pcat "${PCAT}" \
729     --pname "${PNAME}" \
730     --pver "${PVER}" \
731     --pbuild "${PBUILD}" \
732     --parch "${ARCH}"
733     resume_stamp post-md5sum_${PNAME}
734    
735     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
736    
737     # restore smage environment
738     split_restore_variables
739     done
740     # unset all saved smage variables
741     split_unset_variables
742    
743     else
744     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
745     resume_stamp post-pkg_builddir
746    
747     # build pkg-md5-sum if requested
748     run_resume post-md5sum || generate_package_md5sum \
749     --pcat "${PCAT}" \
750     --pname "${PNAME}" \
751     --pver "${PVER}" \
752     --pbuild "${PBUILD}" \
753     --parch "${ARCH}"
754     resume_stamp post-md5sum
755    
756     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
757     fi
758    
759     # build src-pkg-tarball if requested
760     if mqueryfeature "srcpkgbuild"
761     then
762     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
763     resume_stamp post-srcpkgbuild
764     fi
765  fi  fi
766    
767  echo -e "Compressing info-pages ..."  # auto regen mage tree if requested
768  if [ -d ${BUILDDIR}/builded/usr/share/info ]  regen_mage_tree
769    
770    if mqueryfeature "buildlog"
771  then  then
772   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   bzip2 -9f /var/log/smage/${PKGNAME}.log
773    else
774     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
775  fi  fi
776    
 # stripping all bins and libs  
 case ${NOSTRIP} in  
  true|TRUE|yes|y)  
  echo -e "NOSTRIP=true detected; Package will not be stripped ..."  
  ;;  
  *)  
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 #the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  
  echo -e "\nPackage ${PKGNAME} successfully builded.\n"  
  ;;  
 esac  
   
 #for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
777  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.156  
changed lines
  Added in v.2614